;************************************************************************
;* Sega Mark III Port Test Ver 0.1					*
;*									*
;* Programed By Enri (T.H)						*
;************************************************************************
;
;
;
SOUND	EQU	0C000H

;************************************************************************
;* CPU Initialize							*
;*									*
;*									*
;************************************************************************
ORG	00000H
	DI
	IM	1
	LD	SP,0DFFFH
	JR	MAIN
;------------------------------------------------------------------------
;************************************************************************
;* RST 008H Set VDP Address						*
;*									*
;************************************************************************
;* IN:DE=VDP Address							*
;************************************************************************
ORG	00008H
	LD	A,E
	OUT	(0BFH),A
	LD	A,D
	OUT	(0BFH),A
	RET
;------------------------------------------------------------------------
;************************************************************************
;* RST 010H								*
;*									*
;************************************************************************
ORG	00010H

	RET
;------------------------------------------------------------------------
;************************************************************************
;* RST 018H								*
;*									*
;************************************************************************
ORG	00018H

	RET
;------------------------------------------------------------------------
;************************************************************************
;* RST 020H								*
;*									*
;************************************************************************
ORG	00020H

	RET
;------------------------------------------------------------------------
;************************************************************************
;* RST 028H								*
;*									*
;************************************************************************
ORG	00028H

	RET
;------------------------------------------------------------------------
;************************************************************************
;* V-Sync 								*
;*									*
;*									*
;************************************************************************
ORG	00038H

	RETI
;------------------------------------------------------------------------
;************************************************************************
;* Pause Key								*
;*									*
;*									*
;************************************************************************
ORG	00066H

	RETN


;------------------------------------------------------------------------
;************************************************************************
;* Main	Program								*
;*									*
;*									*
;************************************************************************
MAIN:	CALL	PSGOFF
	CALL	VDPINI

	LD	HL,0C000H	;Worak Area Clear
	LD	DE,0C001H
	LD	BC,01FFFH
	LD	(HL),000H
	LDIR

;++++++++++++++++++++
;+ V-RAM Area Clear +
;++++++++++++++++++++
	LD	DE,04000H
	LD	BC,02000H
	LD	HL,00000H
	CALL	VRAMFL
	EI
;
;
;

	LD	A,0E0H		;Screen On
	OUT	(0BFH),A
	LD	A,081H
	OUT	(0BFH),A
	EI

	CALL	SPTOFF

	CALL	SETFNT
	CALL	SETCOL


	LD	DE,07800H
	LD	BC,00380H
	LD	HL,02000H
	CALL	VRAMFL

	CALL	MASGE

LOOPM:	LD	C,03EH
	LD	DE,0784AH
	CALL	RDPORT
	
	LD	C,03FH
	LD	DE,0788AH
	CALL	RDPORT

	LD	C,0DCH
	LD	DE,078CAH
	CALL	RDPORT

	LD	C,0DDH
	LD	DE,0790AH
	CALL	RDPORT

	LD	C,0DEH
	LD	DE,0794AH
	CALL	RDPORT

	LD	C,0DFH
	LD	DE,0798AH
	CALL	RDPORT

;+++++++++++++++
;+ Program End +
;+++++++++++++++
	NOP
	JP	LOOPM

;------------------------------------------------------------------------
;************************************************************************
;* Print MESSAGE							*
;*									*
;************************************************************************
MASGE:	LD	HL,MSGDATA0
	LD	DE,07800H
	CALL	PRTLNG

	INC	HL
	LD	DE,07840H
	CALL	PRTLNG

	INC	HL
	LD	DE,07880H
	CALL	PRTLNG

	INC	HL
	LD	DE,078C0H
	CALL	PRTLNG

	INC	HL
	LD	DE,07900H
	CALL	PRTLNG

	INC	HL
	LD	DE,07940H
	CALL	PRTLNG

	INC	HL
	LD	DE,07980H
	CALL	PRTLNG

	RET

MSGDATA0:	DB	000H,'I/O PORT PEEPING',000H
		DB	000H,'03EH:',000H
		DB	000H,'03FH:',000H
		DB	000H,'0DCH:',000H
		DB	000H,'0DDH:',000H
		DB	000H,'0DEH:',000H
		DB	000H,'0DFH:',000H

;------------------------------------------------------------------------
;************************************************************************
;* Print Length								*
;*									*
;************************************************************************
;* In: HL=MSG Data							*
;*     DE=VDP Address							*
;* Use:A,C,DE,HL							*
;************************************************************************
PRTLNG:	RST	008H
	LD	A,(HL)
	LD	C,A
LPPRLT:	INC	HL

	LD	A,(HL)
	AND	A
	RET	Z

	OUT	(0BEH),A
	LD	A,C
	NOP
	NOP
	OUT	(0BEH),A
	JR	LPPRLT
;------------------------------------------------------------------------
;************************************************************************
;* One Print								*
;*									*
;************************************************************************
;* In: DE=VDP Add							*
;*      A=Data								*
;************************************************************************
ONEPRT:	OUT	(0BEH),A
	NOP
	NOP
	XOR	A
	OUT	(0BEH),A
	NOP
	NOP
	RET

;------------------------------------------------------------------------
;************************************************************************
;* Read Port								*
;*									*
;************************************************************************
;*  In: C=Port								*
;*     DE=VDP Address							*
;************************************************************************
RDPORT:	IN	A,(C)
	CALL	HEXASC
	RST	008H
	LD	A,B
	CALL	ONEPRT
	LD	A,C
	CALL	ONEPRT

	RET

;------------------------------------------------------------------------
;************************************************************************
;* HEX -> ASCII								*
;*									*
;************************************************************************
;*  IN:A=HEX Data							*
;* OUT:C=ASCII Up,B=ASCII Down						*
;************************************************************************
HEXASC:	PUSH	DE
	PUSH	HL

	LD	C,A
	AND	0F0H
	RLCA
	RLCA
	RLCA
	RLCA
	LD	D,00H
	LD	E,A
	LD	HL,ASCTBL
	ADD	HL,DE
	LD	B,(HL)

	LD	A,C
	AND	00FH
	LD	D,00H
	LD	E,A
	LD	HL,ASCTBL
	ADD	HL,DE
	LD	C,(HL)

	POP	HL
	POP	DE
	RET
ASCTBL:	DB	'0123456789ABCDEF'
;------------------------------------------------------------------------
;************************************************************************
;* VDP Initialize							*
;*									*
;************************************************************************
VDPINI:	LD	HL,VDPREG
	LD	BC,016BFH
	OTIR
	RET
;------------
;/ Reg Data /
;------------
VDPREG:	DB	016H,080H,0A0H,081H,0FFH,082H,0FFH,083H
	DB	0FFH,084H,0FFH,085H,0FBH,086H,000H,087H
	DB	000H,088H,000H,089H,0FFH,08AH

;------------------------------------------------------------------------
;************************************************************************
;* Sprite Off		 						*
;*									*
;************************************************************************
SPTOFF:	LD	DE,07F00H	;Sprite Y
	LD	HL,0E0E0H
	LD	BC,00020H
	CALL	VRAMFL
	RET

;------------------------------------------------------------------------
;************************************************************************
;* Set Font		 						*
;*									*
;************************************************************************
SETFNT:	LD	HL,FTDATA
	LD	DE,04000H+(020H*32)
	LD	BC,0040H*8
	CALL	TRFONT
	RET

;------------------------------------------------------------------------
;************************************************************************
;* Set Color Data	 						*
;*									*
;************************************************************************
SETCOL:	LD	HL,CLDATA
	LD	DE,0C000H
	LD	BC,032
	CALL	TRSVDP
	RET

;------------------------------------------------------------------------
;************************************************************************
;* PSG OFF								*
;*									*
;************************************************************************
PSGOFF:	LD	A,09FH
	OUT	(07FH),A
	LD	A,0BFH
	OUT	(07FH),A
	LD	A,0DFH
	OUT	(07FH),A
	LD	A,0FFH
	OUT	(07FH),A
	RET

;------------------------------------------------------------------------
;************************************************************************
;* V-RAM Fill (2Byte)							*
;*									*
;************************************************************************
;* IN:DE=VDP Address							*
;*    BC=Length								*
;*     H=Store Data 1,L=Store Data 2					*
;************************************************************************
VRAMFL:	RST	008H
LPVRMF:	LD	A,H
	OUT	(0BEH),A
	LD	A,L
	OUT	(0BEH),A
	PUSH	AF
	POP	AF

	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,LPVRMF
	RET
;------------------------------------------------------------------------
;************************************************************************
;* Trans Data For V-RAM							*
;*									*
;************************************************************************
;* IN: HL=Character Data Address					*
;*     DE=V-RAM Address							*
;*     BC=Length							*
;************************************************************************
TRSVDP:	RST	008H		;V-RAM Address Set

LPTRSV:	LD	A,(HL)
	OUT	(0BEH),A
	PUSH	AF		;Wait
	POP	AF

	INC	HL
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,LPTRSV

	RET

;------------------------------------------------------------------------
;************************************************************************
;* Trans Font Data For V-RAM						*
;*									*
;************************************************************************
;* IN: HL=Character Data Address					*
;*     DE=V-RAM Address							*
;*     BC=Length							*
;************************************************************************
TRFONT:	RST	008H		;V-RAM Address Set

LPTRF0:	PUSH	BC

	LD	B,004H
LPTRF1:	LD	A,(HL)
	OUT	(0BEH),A
	PUSH	AF		;Wait
	POP	AF
	DJNZ	LPTRF1

	POP	BC

	INC	HL
	DEC	BC
	LD	A,B
	OR	C
	JR	NZ,LPTRF0

	RET

;------------------------------------------------------------------------
;************************************************************************
;* Color Data 								*
;*									*
;************************************************************************
CLDATA:	DB	000H,00CH,008H,00BH,037H,003H,000H,000H
	DB	000H,000H,000H,000H,030H,00CH,003H,03FH

	DB	000H,000H,000H,000H,000H,000H,000H,000H
	DB	000H,000H,000H,000H,000H,000H,000H,002H
;------------------------------------------------------------------------
;************************************************************************
;* Font Data								*
;*									*
;************************************************************************
FTDATA:
	INCLUDE	eefont.inc


;------------------------------------------------------------------------

	ORG	07FF0H
	DB	'Enri Y       ',0FFH,0FFH,0FFH
END
